{  AsmIDE by Eric W. Engler
http://www.ericengler.com/AsmIDE.aspx

The contents of this file are subject to the Mozilla Public License
Version 1.1 (the "License"); you may not use this file except in compliance
with the License. You may obtain a copy of the License at
http://www.mozilla.org/MPL/

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for
the specific language governing rights and limitations under the License.
}

unit frmMain;

{$I SynEdit.inc}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, ActnList, uEditAppIntfs, ComCtrls, frmOptions, AfDataDispatcher,
  AfComPort, ExtCtrls, StdCtrls, AfViewers, AfDataTerminal, frmHelp6812,
  ToolWin, ImgList, ShellAPI, frmAbout, IniFiles, Wytecu, FileCtrl, ClipBrd,
  SynEditPrint, ComObj, SyncObjs, TLHelp32;

const
  WM_DATA_RECEIVED_MESSAGE = WM_USER + 0;
  WM_WRITE_STREAM_DONE_MESSAGE = WM_USER + 1;

type
  TMainForm = class(TForm)
    mnuMain: TMainMenu;
    mFile: TMenuItem;
    miFileExit: TMenuItem;
    miFileNew: TMenuItem;
    N1: TMenuItem;
    mEdit: TMenuItem;
    miFileOpen: TMenuItem;
    miFileSave: TMenuItem;
    miFileSaveAs: TMenuItem;
    miEditUndo: TMenuItem;
    miEditRedo: TMenuItem;
    N2: TMenuItem;
    miEditCut: TMenuItem;
    miEditCopy: TMenuItem;
    miEditPaste: TMenuItem;
    miEditDelete: TMenuItem;
    miEditSelectAll: TMenuItem;
    N3: TMenuItem;
    miEditFind: TMenuItem;
    miEditFindNext: TMenuItem;
    miEditFindPrev: TMenuItem;
    miEditReplace: TMenuItem;
    StatusBar: TStatusBar;
    miViewOptions: TMenuItem;
    mView: TMenuItem;
    N4: TMenuItem;
    mRecentFiles: TMenuItem;
    miFileMRU5: TMenuItem;
    miFileMRU4: TMenuItem;
    miFileMRU3: TMenuItem;
    miFileMRU2: TMenuItem;
    miFileMRU1: TMenuItem;
    N5: TMenuItem;
    miFilePrint: TMenuItem;
    actlStandard: TActionList;
    actFileNew: TAction;
    actFileOpen: TAction;
    actFileExit: TAction;
    actViewOptions: TAction;
    actUpdateStatusBarPanels: TAction;
    AfComPort1: TAfComPort;
    AfDataDispatcher1: TAfDataDispatcher;
    PageControl1: TPageControl;
    tsMessages: TTabSheet;
    tsTerminal: TTabSheet;
    AfDataTerminal1: TAfDataTerminal;
    Build1: TMenuItem;
    Assemble1: TMenuItem;
    actAssemble: TAction;
    actHelp6812: TAction;
    Help1: TMenuItem;
    N6812Instr1: TMenuItem;
    Splitter1: TSplitter;
    ToolBar1: TToolBar;
    tbNew: TToolButton;
    tbOpen: TToolButton;
    tbSave: TToolButton;
    ImageList1: TImageList;
    ToolButton4: TToolButton;
    tbCut: TToolButton;
    tbCopy: TToolButton;
    tbPaste: TToolButton;
    ToolButton8: TToolButton;
    tbFind: TToolButton;
    tbFindNext: TToolButton;
    ToolButton11: TToolButton;
    tbUndo: TToolButton;
    tbRedo: TToolButton;
    ToolButton14: TToolButton;
    tbAssemble: TToolButton;
    tbDownload: TToolButton;
    actDownload: TAction;
    DownloadSeparator1: TMenuItem;
    Download1: TMenuItem;
    OpenDialog1: TOpenDialog;
    HelponAssembler1: TMenuItem;
    actHelpAssem: TAction;
    RichEdit1: TRichEdit;
    actHelpAbout: TAction;
    N7: TMenuItem;
    N8: TMenuItem;
    About1: TMenuItem;
    tbWytec: TToolButton;
    tbWytecSeparator: TToolButton;
    actWytecTools: TAction;
    WytecSeparator1: TMenuItem;
    Wytec1: TMenuItem;
    actHelpMain: TAction;
    MainHelp1: TMenuItem;
    N10: TMenuItem;
    OpenDialog2: TOpenDialog;
    TerminalPopup: TPopupMenu;
    TerminalClearPopItem: TMenuItem;
    TerminalCopyPopItem: TMenuItem;
    TerminalPastePopItem: TMenuItem;
    TerminalLogOnPopItem: TMenuItem;
    TerminalLogOffPopItem: TMenuItem;
    TerminalLogOpenDialog: TOpenDialog;
    PopupMenu: TPopupMenu;
    ClearPopItem: TMenuItem;
    N31: TMenuItem;
    CopyPopItem: TMenuItem;
    tbDumpMemory: TToolButton;
    PageControl2: TPageControl;
    actDumpMemory: TAction;
    N6: TMenuItem;
    DumpMemory1: TMenuItem;
    actPrintDumps: TAction;
    PrintAllDumps1: TMenuItem;
    tbHyperbaud: TToolButton;
    actHyperBaud: TAction;
    N9: TMenuItem;
    actHyperBaud1: TMenuItem;
    actFileClose: TAction;
    miFileClose: TMenuItem;
    N11: TMenuItem;
    PrinterSetupDialog: TPrinterSetupDialog;
    PrinterSetup1: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure mFileClick(Sender: TObject);
    procedure actFileNewOrOpenUpdate(Sender: TObject);
    procedure actFileNewExecute(Sender: TObject);
    procedure actFileOpenExecute(Sender: TObject);
    procedure actFileExitExecute(Sender: TObject);
    procedure mRecentFilesClick(Sender: TObject);
    procedure actViewOptionsExecute(Sender: TObject);
    procedure OnOpenMRUFile(Sender: TObject);
    procedure actUpdateStatusBarPanelsUpdate(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure actAssembleExecute(Sender: TObject);
    procedure actHelp6812Execute(Sender: TObject);
    procedure actDownloadExecute(Sender: TObject);
    procedure actHelpAssemExecute(Sender: TObject);
    procedure actAssembleUpdate(Sender: TObject);
    procedure actDownloadUpdate(Sender: TObject);
    procedure AfDataDispatcher1WriteStreamDone(Sender: TObject);
    procedure actHelpAboutExecute(Sender: TObject);
    procedure actWytecToolsUpdate(Sender: TObject);
    procedure actWytecToolsExecute(Sender: TObject);
    procedure Splitter1Moved(Sender: TObject);
    procedure actHelpMainExecute(Sender: TObject);
    procedure TerminalClearPopItemClick(Sender: TObject);
    procedure TerminalCopyPopItemClick(Sender: TObject);
    procedure TerminalPastePopItemClick(Sender: TObject);
    procedure TerminalLogOnPopItemClick(Sender: TObject);
    procedure TerminalLogOffPopItemClick(Sender: TObject);
    procedure ClearPopItemClick(Sender: TObject);
    procedure CopyPopItemClick(Sender: TObject);
    procedure TerminalPopupPopup(Sender: TObject);
    procedure AfDataTerminal1KeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure actDumpMemoryExecute(Sender: TObject);
    procedure actPrintDumpsExecute(Sender: TObject);
    procedure AfDataDispatcher1DataReceived(Sender: TObject);
    procedure actHyperBaudExecute(Sender: TObject);
    procedure actlStandardUpdate(Action: TBasicAction;
      var Handled: Boolean);
    procedure actDumpMemoryUpdate(Sender: TObject);
    procedure actHyperBaudUpdate(Sender: TObject);
    procedure actFileCloseExecute(Sender: TObject);
    procedure actFileCloseUpdate(Sender: TObject);
    procedure PageControl1Change(Sender: TObject);
    procedure PrinterSetup1Click(Sender: TObject);
    procedure PageControl1Enter(Sender: TObject);
  private
    fEditorForm: IEditor;
   // fListForm: IEditor;
    fListSheet: TTabSheet;
    NowAssembling, NowDownloading, FirstTime, GoodAssembly: Boolean;
    fAutoLoad, fAutoGo, AnyDataLastStringReceived: string;
    slAutoDump: TStringList;
    MainSheet: TTabSheet;
    DumpTabSheetCount: Integer;
    DumpTabSheetAry: array[0..14] of TTabSheet;
    DumpLabel1Ary: array[0..14] of TLabel;
    DumpLabel2Ary: array[0..14] of TLabel;
    DumpRangeLabelAry: array[0..14] of TLabel;
    DumpRegisterMemoAry: array[0..14] of TMemo;
    DumpMemoryMemoAry: array[0..14] of TMemo;
    rtfPrint: TRichEdit;
    WriteStreamDone, WatchForAnyData: Boolean;
    RegisterDumpData: string;
    IncomingData: string;
    InHyperBaud: Boolean;
    ListEditor: IEditor;
    bCallingFromDownload: boolean;

    function ExecuteCombined(CommandLine: string; strCombinedOut: TStrings; var ExitCode: DWORD): DWORD;
    procedure ReadIniSettings;
    procedure WriteIniSettings;
    procedure UpgradeIniFromLastVersion;
    procedure SendToTerminal(s: string);
    function ExecAndWait(const CommandLine: string): boolean;
    function GetAutoCommands: boolean;
    function Parse(const s: string; const key: string; var idx: integer): string;
    procedure CreateDumpWindow(aCaption: string);
    procedure CreateListWindow(aFilename: string);
    procedure CloseAllDumpWindows;
    procedure AddPrintLine(s: string; FontSize: integer; Bold: Boolean);
    function PerformDumps: Boolean;
    procedure PerformDump(cmd: string; itab: integer);
    procedure PerformRegisterDump;
    procedure PerformBinloadDownload(Filename: string);
    procedure PerformPlutoDownload(Filename: string);
    procedure SendText(s: string);
    function PerformAutoCommands(Filename: string): Boolean;
    function MonitorIsResponding: Boolean;
    procedure OnDataReceivedMessage(var Msg: TMessage); message WM_DATA_RECEIVED_MESSAGE;
    procedure OnWriteStreamDoneMessage(var Msg: TMessage); message WM_WRITE_STREAM_DONE_MESSAGE;
    procedure CloseListWindow;

  protected
    fMRUItems: array[1..5] of TMenuItem;

    function DoCreateEditor(AFileName: string): IEditor;
    function CanCloseAll: boolean;
    function CmdLineOpenFiles(AMultipleFiles: boolean): boolean;
    procedure DoOpenFile(AFileName: string);

  public
    SelectedFamily, AssemblerPath, HelpFilePath, CurrentFilename, AppDir,
      LastFolder, WytecDebuggerPath, WytecProgrammerPath, WytecBoard, WytecMPUType,
      WytecCOMPort, SRecCvtCmd, OurPath, LastStringReceived, MonitorLastStringReceived, LastFilename: string;
    iniFile: TIniFile;
    EnableCOMPort, WytecEnabled: Boolean;
    EnableAutoLoad, EnableAutoGo, EnableAutoDump, WatchForAutoDump, WatchForMonitorReady: Boolean;
    baud: string;
    Databits, BinloadAndPlutoPort: integer;
    Stopbits, Parity, FlowControl: string;
    F2String, F3String, F4String, F5String, F6String, F7String, F8String, F9String, F10String, F11String, F12String: string;

    procedure UpdateFilename;
    procedure SetupCOMPort;
    function WytecConflict: Boolean;
  end;

const
  ERR_BASE = $20000000; // This won't conflict with GetErrorCode range
  ERR_STDOUT = ERR_BASE + 1;
  ERR_STDERR = ERR_BASE + 2;

var
  MainForm: TMainForm;

implementation

{$R *.DFM}

uses
  dmCommands;

{ TMainForm }

procedure TMainForm.OnDataReceivedMessage(var Msg: TMessage);
var
 // cmd: Integer;
  i: integer;
  s: string;
 // pc: PChar;
begin
  s := PChar(Integer(msg.WParam));
  try
    // This is used to determine if the monitor is responding to our commands
    if WatchForMonitorReady and (SelectedFamily = '68hc12') then
    begin
      MonitorLastStringReceived := MonitorLastStringReceived + s;
      i := Length(MonitorLastStringReceived);
      if (i > 1) and ((MonitorLastStringReceived[i - 1] = #10) or (MonitorLastStringReceived[i - 1] = #13))
        and (MonitorLastStringReceived[i] = '>') then
      begin
        WatchForMonitorReady := False;
        Exit;
      end;
    end
    else
      MonitorLastStringReceived := '';

    // This is used to discover when we need to do an autodump
    if WatchForAutoDump and (SelectedFamily = '68hc12') then
    begin
      LastStringReceived := LastStringReceived + s;
      i := Length(LastStringReceived);
      if (i > 1) and ((LastStringReceived[i - 1] = #10) or (LastStringReceived[i - 1] = #13))
        and (LastStringReceived[i] = '>') then
      begin
        WatchForAutoDump := False;
        AfDataTerminal1.SetFocus;
        PerformDumps;
        Exit;
      end;
    end
    else
      LastStringReceived := '';

    // This is used to accumulate actual dump data, and maybe other stuff
    if WatchForAnyData and (SelectedFamily = '68hc12') then
    begin
      AnyDataLastStringReceived := AnyDataLastStringReceived + s;
      i := Length(AnyDataLastStringReceived);
      if (i > 1) and ((AnyDataLastStringReceived[i - 1] = #10) or (AnyDataLastStringReceived[i - 1] = #13))
        and (AnyDataLastStringReceived[i] = '>') then
      begin
        WatchForAnyData := False;
        Exit;
      end;
    end
    else
      AnyDataLastStringReceived := '';
  except
    on E: Exception do
    begin
      MessageDlg('OnDataReceived Exception: ' + E.Message, mtError, [mbOK], 0);
    end;
  end;

end;

procedure TMainForm.OnWriteStreamDoneMessage(var Msg: TMessage);
var
  cmd: Integer;
begin
  cmd := Integer(msg.WParam);
  if cmd = 1 then
  begin
    try
      WriteStreamDone := True;
      NowDownloading := False; // enable the Download button
      actDownloadUpdate(self);
    except
      on E: Exception do
      begin
        MessageDlg('OnWriteStreamDone Exception: ' + E.Message, mtError, [mbOK], 0);
      end;
    end;
  end;
end;

// Create a new editor thru an Interface

function TMainForm.DoCreateEditor(AFileName: string): IEditor;
begin
  if fEditorForm <> nil then
    Result := fEditorForm
  else if GI_EditorFactory <> nil then
  begin
    fEditorForm := GI_EditorFactory.CreateTabSheet(PageControl2);
    Result := fEditorForm;
  end
  else
    Result := nil;
end;

procedure TMainForm.UpgradeINIFromLastVersion;
var
  asmBatFile, wytecPath, wytecFileToReplace: string;
  fileDate, cutoffDate: TDateTime;
begin
  // Translate old binload config item to new Download Radio Group option
  if iniFile.ReadInteger('Download6812', 'option', -1) = -1 then
  begin
    // new Radio Group option not set yet, so pick binload or d-bug12
    if iniFile.ReadBool('binload', 'enabled', False) then
      iniFile.WriteInteger('Download6812', 'option', 1) // use binload
    else
      iniFile.WriteInteger('Download6812', 'option', 0); // use d-bug12 "load"
  end;

  // older stuff:

  // update the commandline switches to the new as11 format
  if Trim(iniFile.ReadString('CommandLine', 'as11CommandLine', '% -o@.s19 -L@.lst -s')) = '-lo -s %' then
    iniFile.WriteString('CommandLine', 'as11CommandLine', '% -o@.s19 -L@.lst -s');

  // update the wytec tools batch file if this user was using it
  asmBatFile := Trim(iniFile.ReadString('Assembler', 'hc11AssemblerPath', ''));
  if (UpperCase(ExtractFileName(asmBatFile)) = 'MYASM11.BAT') and FileExists('WDOASM11.DAT') and FileExists(asmBatFile) then
  begin
    // this user is using the wytec batch files
    wytecPath := IncludeTrailingBackSlash(ExtractFilePath(asmBatFile));
    wytecFileToReplace := wytecPath + 'WDOASM11.BAT';
    if FileExists(wytecFileToReplace) then
    begin
      fileDate := FileDateToDateTime(FileAge(wytecFileToReplace));
      ShortDateFormat := 'mm/dd/yy';
      cutoffDate := StrToDate('05/01/05');
      if fileDate < cutoffDate then
      begin
        // user's file is too old, copy in the new one
        CopyFile(pchar('WDOASM11.DAT'), pchar(wytecFileToReplace), false);
      end;
    end;
  end;
end;

procedure TMainForm.FormCreate(Sender: TObject);
var
  PlutoIniFile: TIniFile;
begin
  LastFilename := '';
  DumpTabSheetCount := 0;
  MainSheet := nil;
  ListEditor := nil;
  slAutoDump := TStringList.Create;
  InHyperBaud := False;
  bCallingFromDownload := False;

  WatchForAutoDump := False;
  OurPath := IncludeTrailingBackslash(ExtractFileDir(Application.ExeName));
  Application.HelpFile := IncludeTrailingBackslash(ExtractFileDir(Application.ExeName)) + 'AsmIDE.chm';

  iniFile := TIniFile.Create(ChangeFileExt(Application.ExeName, '.ini'));
  UpgradeINIFromLastVersion;

  // clear the autoload filename for pluto - don't want it to load the wrong file
  // if user starts it himself without clicking the Download button in AsmIDE
  PlutoIniFile := TIniFile.Create(OurPath + 'pluto-autoload.ini');
  PlutoIniFile.WriteString('Autoload', 'Filename', '');
  PlutoIniFile.Free;

  PageControl1.ActivePage := tsMessages;
  NowAssembling := False;
  NowDownloading := False;
  StatusBar.Visible := True;

  fMRUItems[1] := miFileMRU1;
  fMRUItems[2] := miFileMRU2;
  fMRUItems[3] := miFileMRU3;
  fMRUItems[4] := miFileMRU4;
  fMRUItems[5] := miFileMRU5;
  CommandsDataModule := TCommandsDataModule.Create(Self);

  ReadIniSettings;

  if FirstTime then
  begin
    if MessageDlg('Your COM port has not been set up. Do you want to do that now?',
      mtConfirmation, [mbYes, mbNo], 0) = mrYes then
    begin
      actViewOptionsExecute(self);
    end
    else
    begin
      EnableCOMPort := False;
      iniFile.WriteBool('COM PORT', 'EnableCOMPort', False);
      if not WytecEnabled then
        MessageDlg('Your Terminal Window will not function until the COM port is setup',
          mtInformation, [mbOk], 0);
    end;
    FirstTime := False;
  end;

  if EnableCOMPort and (AfComPort1.ComNumber > 0) and (iniFile.ReadInteger('Download6812', 'option', 0) <> 2) then
  begin
    // Turn-on the COM port
    try
      afDataTerminal1.Enabled := True;
      tsTerminal.TabVisible := True;
      AfComPort1.Open;
      AfDataDispatcher1.Clear;
    except
      on E: Exception do
      begin
        MessageDlg('Can not open COM port', mtError, [mbOK], 0);
        EnableCOMPort := False;
      end;
    end;
  end
  else
  begin
    afDataTerminal1.Enabled := False;
    tsTerminal.TabVisible := False;
  end;

  if not CmdLineOpenFiles(FALSE) then
    DoOpenFile('');
end;

procedure TMainForm.FormDestroy(Sender: TObject);
var
  PlutoIniFile: TIniFile;
begin
  // clear the autoload filename for pluto - don't want it to load the wrong file
  // if user starts it himself without clicking the Download button in AsmIDE
  PlutoIniFile := TIniFile.Create(OurPath + 'pluto-autoload.ini');
  PlutoIniFile.WriteString('Autoload', 'Filename', '');
  PlutoIniFile.Free;

  CloseAllDumpWindows;
  CloseListWindow;

  AfDataDispatcher1.DataProvider := nil;
  AfComPort1.Close;
  slAutoDump.Free;
  if GI_EditorFactory <> nil then
    GI_EditorFactory.CloseAll;
  WriteIniSettings;
  CommandsDataModule.Free;
  iniFile.Free;
end;

function TMainForm.CanCloseAll: boolean;
begin
  Result := TRUE;
end;

function TMainForm.CmdLineOpenFiles(AMultipleFiles: boolean): boolean;
var
  i, Cnt: integer;
begin
  Cnt := ParamCount;
  if Cnt > 0 then
  begin
    if not AMultipleFiles and (Cnt > 1) then
      Cnt := 1;
    for i := 1 to Cnt do
      DoOpenFile(ParamStr(i));
    Result := TRUE;
  end
  else
  begin
    if (LastFilename > '') and iniFile.ReadBool('CurrentFile', 'ReopenLastFile', True)
      and FileExists(LastFilename) then
    begin
      DoOpenFile(LastFilename);
      Result := True;
    end
    else
      Result := FALSE;
  end;
end;

procedure TMainForm.DoOpenFile(AFileName: string);
var
  i: integer;
  LEditor: IEditor;
begin
  CloseAllDumpWindows;
  CloseListWindow;

  AFileName := ExpandFileName(AFileName);

  if (AFileName = CurrentFilename) and (AFileName > '') then
  begin
    // EWE: See if this file is already open. We can't edit 2 files at the same time (SDI app - one file to edit, and many dump windows).
    // If the same file is requested, the user probably wants to reload it.
    if GI_EditorFactory <> nil then
    begin
      for i := GI_EditorFactory.GetEditorCount - 1 downto 0 do
      begin
        LEditor := GI_EditorFactory.Editor[i];

        if CompareText(LEditor.GetFileName, AFileName) = 0 then
        begin
          LEditor.Activate;
          // EWE: I'm not sure why I did this, but it was a bad idea!
          // LEditor.Close; // close file
          // LEditor.OpenFile(AFileName); // reopen the file
          exit;
        end;
      end;
    end;
  end;

  // do we have a file open now?
  if CurrentFilename > '' then
  begin
    actFileCloseExecute(self);
  end;

  // create a new editor, add it to the editor list, open the file
  LEditor := DoCreateEditor(AFileName);
  if LEditor <> nil then
  begin
    LEditor.OpenFile(AFileName);
    CurrentFilename := AFileName;
    if AFilename > '' then
    begin
      iniFile.WriteString('Current File', 'CurrentFullPathName', AFileName);
      // the file we open is never on the Most Recently Used list because it is open
      CommandsDataModule.RemoveMRUEntry(AFileName);
    end
  end
  else
    CurrentFilename := '';
  UpdateFilename;
end;

procedure TMainForm.UpdateFilename;
begin
  if CurrentFilename = '' then
    Caption := 'AsmIDE - <no filename>'
  else
    Caption := 'AsmIDE - ' + CurrentFilename;
end;

procedure TMainForm.ReadIniSettings;
var
  x, y, w, h: integer;
  i: integer;
  s: string;
begin
  x := iniFile.ReadInteger('Main', 'Left', 0);
  y := iniFile.ReadInteger('Main', 'Top', 0);
  w := iniFile.ReadInteger('Main', 'Width', 0);
  h := iniFile.ReadInteger('Main', 'Height', 0);
  if (w > 0) and (h > 0) then
    SetBounds(x, y, w, h);
  PageControl1.Height := iniFile.ReadInteger('Main', 'PageControlHeight', 120);
  if PageControl1.Height < 20 then
    PageControl1.Height := 20;
  StatusBar.Top := PageControl1.Height + PageControl1.Top;

  if iniFile.ReadInteger('Main', 'Maximized', 0) <> 0 then
    WindowState := wsMaximized;

  // MRU (most recently used) files
  for i := 5 downto 1 do
  begin
    s := iniFile.ReadString('MRUFiles', Format('MRUFile%d', [i]), '');
    if s <> '' then
      CommandsDataModule.AddMRUEntry(s);
  end;

  AppDir := ExtractFilePath(Application.ExeName);

  SelectedFamily := iniFile.ReadString('Assembler', 'SelectedFamily', 'NONE');
  if SelectedFamily = 'NONE' then
  begin
    // This is the first time the user ran this program from this folder
    // Set up the initial INI file options
    FirstTime := True;
    if FileExists(AppDir + 'as8.exe') then
      iniFile.WriteString('Assembler', '6808AssemblerPath', AppDir + 'as8.exe')
    else
      iniFile.WriteString('Assembler', '6808AssemblerPath', 'as8.exe');
    if FileExists(AppDir + 'as8.txt') then
      iniFile.WriteString('Assembler', '6808HelpPath', AppDir + 'as8.txt')
    else
      iniFile.WriteString('Assembler', '6808HelpPath', 'as8.txt');

    if FileExists(AppDir + 'as9.exe') then
      iniFile.WriteString('Assembler', '6809AssemblerPath', AppDir + 'as9.exe')
    else
      iniFile.WriteString('Assembler', '6809AssemblerPath', 'as9.exe');
    if FileExists(AppDir + 'as9.txt') then
      iniFile.WriteString('Assembler', '6809HelpPath', AppDir + 'as9.txt')
    else
      iniFile.WriteString('Assembler', '6809HelpPath', 'as9.txt');

    if FileExists(AppDir + 'as11.exe') then
      iniFile.WriteString('Assembler', 'hc11AssemblerPath', AppDir + 'as11.exe')
    else
      iniFile.WriteString('Assembler', 'hc11AssemblerPath', 'as11.exe');
    if FileExists(AppDir + 'as11.htm') then
      iniFile.WriteString('Assembler', 'hc11HelpPath', AppDir + 'as11.htm')
    else
      iniFile.WriteString('Assembler', 'hc11HelpPath', 'as11.htm');

    if FileExists(AppDir + 'as12.exe') then
      iniFile.WriteString('Assembler', 'hc12AssemblerPath', AppDir + 'as12.exe')
    else
      iniFile.WriteString('Assembler', 'hc12AssemblerPath', 'as12.exe');
    if FileExists(AppDir + 'as12.htm') then
      iniFile.WriteString('Assembler', 'hc12HelpPath', AppDir + 'as12.htm')
    else
      iniFile.WriteString('Assembler', 'hc12HelpPath', 'as12.htm');

    // initial setup of Wytec tools
    if FileExists('c:\ep2ide\mydebug.bat') then
    begin
      // if we find the Wytec tools, assume that is what the user will be using
      // instead of our terminal window
      WytecEnabled := True;
      WytecDebuggerPath := 'c:\ep2ide\mydebug.bat';
      WytecProgrammerPath := 'c:\ep2ide\myprgm.bat';
      WytecBoard := 'EVBplus';
      WytecMPUType := '1 = 68HC11A0,A1,A8';
      WytecCOMPort := 'COM 1';
    end
    else
    begin
      WytecEnabled := False;
      WytecDebuggerPath := '';
      WytecProgrammerPath := '';
      WytecBoard := '';
      WytecMPUType := '';
      WytecCOMPort := '';
    end;
    iniFile.WriteBool('Wytec', 'Enabled', WytecEnabled);
    iniFile.WriteString('Wytec', 'COM Port', WytecCOMPort);
    iniFile.WriteString('Wytec', 'DebuggerPath', WytecDebuggerPath);
    iniFile.WriteString('Wytec', 'ProgrammerPath', WytecProgrammerPath);
    iniFile.WriteString('Wytec', 'Board', WytecBoard);
    iniFile.WriteString('Wytec', 'MPU', WytecMPUType);

    LastFolder := AppDir;
    iniFile.WriteString('Main', 'LastFolder', LastFolder);

    // Always default to 6812 as the selected family the first time
    SelectedFamily := '68hc12';
    iniFile.WriteString('Assembler', 'SelectedFamily', SelectedFamily);

    iniFile.WriteString('SRecCVT', 'CommandLine', '');
    iniFile.WriteInteger('Download6812', 'option', 0);
  end
  else
  begin
    // We found the old settings in the INI file:
    FirstTime := False;
    if SelectedFamily = '6808' then
    begin
      AssemblerPath := iniFile.ReadString('Assembler', '6808AssemblerPath', '');
      HelpFilePath := iniFile.ReadString('Assembler', '6808HelpPath', '');
    end
    else if SelectedFamily = '6809' then
    begin
      AssemblerPath := iniFile.ReadString('Assembler', '6809AssemblerPath', '');
      HelpFilePath := iniFile.ReadString('Assembler', '6809HelpPath', '');
    end
    else if SelectedFamily = '68hc11' then
    begin
      AssemblerPath := iniFile.ReadString('Assembler', 'hc11AssemblerPath', '');
      HelpFilePath := iniFile.ReadString('Assembler', 'hc11HelpPath', '');
    end
    else if SelectedFamily = '68hc12' then
    begin
      AssemblerPath := iniFile.ReadString('Assembler', 'hc12AssemblerPath', '');
      HelpFilePath := iniFile.ReadString('Assembler', 'hc12HelpPath', '');
    end;

    // Assume Wytec is enabled if the new "Enabled" INI entry isn't found.
    // But we'll disable it if the debugger isn't found.
    WytecEnabled := iniFile.ReadBool('Wytec', 'Enabled', True);
    WytecCOMPort := iniFile.ReadString('Wytec', 'COM Port', 'COM 1');
    WytecDebuggerPath := iniFile.ReadString('Wytec', 'DebuggerPath', '');
    if not FileExists(WytecDebuggerPath) then
      WytecEnabled := False; // Disable Wytec menu
    WytecProgrammerPath := iniFile.ReadString('Wytec', 'ProgrammerPath', '');
    WytecBoard := iniFile.ReadString('Wytec', 'Board', '');
    WytecMPUType := iniFile.ReadString('Wytec', 'MPU', '');
  end;

  if WytecEnabled and WytecConflict then
  begin
    MessageDlg('Disabling Terminal Window to allow Wytec tools to work', mtWarning, [mbOK], 0);
    iniFile.WriteBool('COM PORT', 'EnableCOMPort', False); // disable terminal window
  end;

  // Configure Terminal Window COM Port
  EnableCOMPort := iniFile.ReadBool('COM PORT', 'EnableCOMPort', False);
  if EnableCOMPort then
  begin
    SetupCOMPort; // this won't turn the port on
  end;

  SRecCvtCmd := iniFile.ReadString('SRecCVT', 'CommandLine', '');
  BinloadAndPlutoPort := iniFile.ReadInteger('BinLoad', 'COM Port', 1);

  // we reserve F1 for help
  F2String := iniFile.ReadString('TerminalFunctionKeys', 'F2', 'FBULK');
  F3String := iniFile.ReadString('TerminalFunctionKeys', 'F3', 'FPROG ;b');
  F4String := iniFile.ReadString('TerminalFunctionKeys', 'F4', 'LOAD');
  F5String := iniFile.ReadString('TerminalFunctionKeys', 'F5', 'g 2000');
  F6String := iniFile.ReadString('TerminalFunctionKeys', 'F6', '');
  F7String := iniFile.ReadString('TerminalFunctionKeys', 'F7', '');
  F8String := iniFile.ReadString('TerminalFunctionKeys', 'F8', '');
  F9String := iniFile.ReadString('TerminalFunctionKeys', 'F9', '');
  F10String := iniFile.ReadString('TerminalFunctionKeys', 'F10', '');
  F11String := iniFile.ReadString('TerminalFunctionKeys', 'F11', '');
  F12String := iniFile.ReadString('TerminalFunctionKeys', 'F12', '');

  LastFilename := iniFile.ReadString('Current File', 'CurrentFullPathName', '');
end;

// Determine if Wytec and the terminal window are using the same port

function TMainForm.WytecConflict: Boolean;
begin
  Result := False;
  if not iniFile.ReadBool('COM PORT', 'EnableCOMPort', False) then
    Exit; // main com port is disabled - there is no conflict possible

  // Wytec tools only support COM1 and COM2
  if (WytecCOMPort = 'COM 1') and (iniFile.ReadInteger('COM PORT', 'COM Number', 0) = 1) then
    Result := True
  else if (WytecCOMPort = 'COM 2') and (iniFile.ReadInteger('COM PORT', 'COM Number', 0) = 2) then
    Result := True;
end;

// Only come here if the COM port is not disabled. This won't turn the port on.

procedure TMainForm.SetupCOMPort;
begin
  AfComPort1.ComNumber := iniFile.ReadInteger('COM PORT', 'COM Number', 1);
  Baud := iniFile.ReadString('COM PORT', 'Baud Rate', '9600');
  Databits := iniFile.ReadInteger('COM PORT', 'Databits', 8);
  Stopbits := iniFile.ReadString('COM PORT', 'Stopbits', '1');
  Parity := iniFile.ReadString('COM PORT', 'Parity', 'None');
  FlowControl := iniFile.ReadString('COM PORT', 'FlowControl', 'XOnXOff');

  if Baud = '300' then
    afComPort1.BaudRate := br300
  else if Baud = '1200' then
    afComPort1.BaudRate := br1200
  else if Baud = '2400' then
    afComPort1.BaudRate := br2400
  else if Baud = '4800' then
    afComPort1.BaudRate := br4800
  else if Baud = '9600' then
    afComPort1.BaudRate := br9600
  else if Baud = '19200' then
    afComPort1.BaudRate := br19200
  else if Baud = '38400' then
    afComPort1.BaudRate := br38400
  else if Baud = '57600' then
    afComPort1.BaudRate := br57600
  else if Baud = '115200' then
    afComPort1.BaudRate := br115200
  else
    afComPort1.BaudRate := br9600; // default

  if Databits = 4 then
    AfComPort1.Databits := db4
  else if Databits = 5 then
    AfComPort1.Databits := db5
  else if Databits = 6 then
    AfComPort1.Databits := db6
  else if Databits = 7 then
    AfComPort1.Databits := db7
  else if Databits = 8 then
    AfComPort1.Databits := db8;

  if Stopbits = '1' then
    AfComPort1.Stopbits := sbOne
  else if Stopbits = '1.5' then
    AfComPort1.Stopbits := sbOneAndHalf
  else if Stopbits = '2' then
    AfComPort1.Stopbits := sbTwo;

  if Uppercase(Parity) = 'NONE' then
    AfComPort1.Parity := paNone
  else if Uppercase(Parity) = 'ODD' then
    AfComPort1.Parity := paOdd
  else if Uppercase(Parity) = 'EVEN' then
    AfComPort1.Parity := paEven
  else if Uppercase(Parity) = 'MARK' then
    AfComPort1.Parity := paMark
  else if Uppercase(Parity) = 'SPACE' then
    AfComPort1.Parity := paSpace;

  if Uppercase(FlowControl) = 'NONE' then
    AfComPort1.FlowControl := fwNone
  else if Uppercase(FlowControl) = 'XONXOFF' then
    AfComPort1.FlowControl := fwXOnXOff
  else if Uppercase(FlowControl) = 'RTSCTS' then
    AfComPort1.FlowControl := fwRtsCts
  else if Uppercase(FlowControl) = 'DTRDSR' then
    AfComPort1.FlowControl := fwDtrDsr;
end;

procedure TMainForm.WriteIniSettings;
var
  wp: TWindowPlacement;
  i: integer;
  s: string;
begin
  wp.length := SizeOf(TWindowPlacement);
  GetWindowPlacement(Handle, @wp);
  // form properties
  with wp.rcNormalPosition do
  begin
    iniFile.WriteInteger('Main', 'Left', Left);
    iniFile.WriteInteger('Main', 'Top', Top);
    iniFile.WriteInteger('Main', 'Width', Right - Left);
    iniFile.WriteInteger('Main', 'Height', Bottom - Top);
    iniFile.WriteInteger('Main', 'PageControlHeight', PageControl1.Height);
  end;
  iniFile.WriteInteger('Main', 'Maximized', Ord(WindowState = wsMaximized));
  iniFile.WriteString('Main', 'LastFolder', LastFolder);

  // MRU files
  for i := 1 to 5 do
  begin
    s := CommandsDataModule.GetMRUEntry(i - 1);
    if s <> '' then
      iniFile.WriteString('MRUFiles', Format('MRUFile%d', [i]), s)
    else
      iniFile.DeleteKey('MRUFiles', Format('MRUFile%d', [i]));
  end;
end;

// action handler methods

procedure TMainForm.actFileNewOrOpenUpdate(Sender: TObject);
begin
  (Sender as TAction).Enabled := GI_EditorFactory <> nil;
end;

procedure TMainForm.actFileNewExecute(Sender: TObject);
begin
  if MessageDlg('Do you want to create a new file?', mtConfirmation, [mbYes, mbNo], 0) = mrYes then
    DoOpenFile('');
end;

procedure TMainForm.CloseListWindow;
begin
  // i can get an exception here if user put mouse in the list editor window and tried to edit
  if (ListEditor <> nil) then
  begin
    PageControl2.ActivePageIndex := 0; // select main sheet
    try
      ListEditor.Activate;
    except
      //
    end;
    try
      ListEditor.Close;
    except
      //
    end;
    try
      FreeAndNil(ListEditor);
    except
      //
    end;
  end;
end;

procedure TMainForm.actFileOpenExecute(Sender: TObject);
begin
  CloseAllDumpWindows;
  CloseListWindow;

  with CommandsDataModule.dlgFileOpen do
  begin
    InitialDir := LastFolder;
    if Execute then
    begin
      LastFolder := ExtractFilePath(Filename);
      DoOpenFile(FileName);
    end;
  end;
end;

procedure TMainForm.actFileExitExecute(Sender: TObject);
begin
  Application.HelpCommand(HELP_QUIT, 0); //close the help file if open
  Close;
end;

procedure TMainForm.mRecentFilesClick(Sender: TObject);
var
  i: integer;
  s: string;
begin
  for i := Low(fMRUItems) to High(fMRUItems) do
    if fMRUItems[i] <> nil then
    begin
      s := CommandsDataModule.GetMRUEntry(i - Low(fMRUItems));
      fMRUItems[i].Visible := s <> '';
      fMRUItems[i].Caption := s;
    end;
end;

procedure TMainForm.mFileClick(Sender: TObject);
begin
  mRecentFiles.Enabled := CommandsDataModule.GetMRUEntries > 0;
end;

procedure TMainForm.actViewOptionsExecute(Sender: TObject);
var
  OptionsForm: TOptionsForm;
begin
  inherited;
  OptionsForm := TOptionsForm.Create(nil);
  try
    OptionsForm.ShowModal;
  finally
    OptionsForm.Free;
  end;
  // For some reason this Update procs weren't firing at this point in the code,
  // so I am calling them myself.
  actWytecToolsUpdate(self);
  actDownloadUpdate(self);
end;

// TODO: MRU not working?

procedure TMainForm.OnOpenMRUFile(Sender: TObject);
var
  i: integer;
  s: string;
begin
  for i := Low(fMRUItems) to High(fMRUItems) do
    if Sender = fMRUItems[i] then
    begin
      s := CommandsDataModule.GetMRUEntry(i - 1);
      if s <> '' then
        DoOpenFile(s);
    end;
end;

procedure TMainForm.actUpdateStatusBarPanelsUpdate(Sender: TObject);
resourcestring
  SModified = 'Modified';
var
  ptCaret: TPoint;
begin
  actUpdateStatusBarPanels.Enabled := TRUE;
  if GI_ActiveEditor <> nil then
  begin
    ptCaret := GI_ActiveEditor.GetCaretPos;
    if (ptCaret.X > 0) and (ptCaret.Y > 0) then
      StatusBar.Panels[0].Text := Format(' %6d:%3d ', [ptCaret.Y, ptCaret.X])
    else
      StatusBar.Panels[0].Text := '';
    if GI_ActiveEditor.GetModified then
      StatusBar.Panels[1].Text := SModified
    else
      StatusBar.Panels[1].Text := '';
    StatusBar.Panels[2].Text := GI_ActiveEditor.GetEditorState;
  end
  else
  begin
    StatusBar.Panels[0].Text := '';
    StatusBar.Panels[1].Text := '';
    StatusBar.Panels[2].Text := '';
  end;
end;

procedure TMainForm.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  if GI_EditorFactory <> nil then
    CanClose := GI_EditorFactory.CanCloseAll;
end;

procedure TMainForm.actAssembleExecute(Sender: TObject);
var
  ReturnCode: DWORD;
  ExitCode: DWORD;
  msg, msg2, cmd, BuildDir, Filename, FnameNoExt, CommandLine, BatchFile: string;
  DoSrecCvt: Boolean;
  Strlist1, Strlist2: TStringList;
  i: Integer;
begin
  GoodAssembly := True; // init
  CloseAllDumpWindows;
  CloseListWindow;

  if CommandsDataModule.actFileSave.Enabled then
  //if (not CommandsDataModule. .FileHasBeenSaved) then
  begin
    if (CurrentFileName > '') and (iniFile.ReadBool('AutoFunctions', 'Autosave', True)) then
    begin
      Application.ProcessMessages;
      //CommandsDataModule.actFileSave.Execute;   // works first time, second time calls Update inst of Execute!
      CommandsDataModule.MyFileSave;
    end
    else
    begin
      if Application.MessageBox('Do you want to save your changes first?',
        'Save Changes',
        MB_YESNO + MB_DEFBUTTON1) = IDYES then
      begin
        CommandsDataModule.MyFileSaveAs;
      end;
    end;
  end;

  if (CurrentFileName = '') or (not iniFile.ReadBool('AutoFunctions', 'NoAssemblingFileNamePrompt', True)) then
  begin
    with OpenDialog2 do
    begin
      if CurrentFileName > '' then
        Filename := CurrentFileName; // dflt to current file already open
      InitialDir := LastFolder;
      if Uppercase(ExtractFileExt(Filename)) = '.ASM' then
        FilterIndex := 1
      else if Uppercase(ExtractFileExt(Filename)) = '.S' then
        FilterIndex := 2
      else if Uppercase(ExtractFileExt(Filename)) = '.H' then
        FilterIndex := 3
      else
        FilterIndex := 1;
      if Execute then
      begin
        if UpperCase(CurrentFilename) <> UpperCase(Filename) then
          DoOpenFile(FileName); // user picked a different file, or maybe there was no file loaded before
        CurrentFilename := Filename;
      end
      else
        exit;
    end;
  end;

  PageControl1.ActivePage := tsMessages;
  RichEdit1.Lines.Clear;

  if SelectedFamily = '6808' then
    AssemblerPath := iniFile.ReadString('Assembler', '6808AssemblerPath', '')
  else if SelectedFamily = '6809' then
    AssemblerPath := iniFile.ReadString('Assembler', '6809AssemblerPath', '')
  else if SelectedFamily = '68hc11' then
    AssemblerPath := iniFile.ReadString('Assembler', 'hc11AssemblerPath', '')
  else if SelectedFamily = '68hc12' then
    AssemblerPath := iniFile.ReadString('Assembler', 'hc12AssemblerPath', '');

  if not FileExists(AssemblerPath) then
  begin
    MessageDlg('Can not find the Assembler - Please check View..Options'
      + #13#10 + AssemblerPath, mtError, [mbOK], 0);
    Exit;
  end;

  NowAssembling := True; // disable the Assemble Button
  Strlist1 := TStringList.Create;
  Strlist2 := TStringList.Create;
  try
    Application.ProcessMessages;

    BuildDir := ExtractFilePath(CurrentFilename);
    Filename := ExtractFileName(CurrentFilename);
    FnameNoExt := ChangeFileExt(Filename, '');
    iniFile.WriteString('Current File', 'CurrentFullPathName', BuildDir + Filename);
    iniFile.WriteString('Current File', 'CurrentFilename', Filename);
    iniFile.WriteString('Current File', 'CurrentFilenameNoExt', FnameNoExt);
    iniFile.WriteString('Current File', 'CurrentBuildDir', ExcludeTrailingBackslash(BuildDir));
    ChDir(BuildDir);

    // We need quotes around all filenames to support embedded spaces
    if SelectedFamily = '6808' then
    begin
      CommandLine := iniFile.ReadString('CommandLine', '6808CommandLine', '-lo -s %');
      BatchFile := iniFile.ReadString('CommandLine', '6808BatchFile', '');
    end
    else if SelectedFamily = '6809' then
    begin
      CommandLine := iniFile.ReadString('CommandLine', '6809CommandLine', '-lo -s %');
      BatchFile := iniFile.ReadString('CommandLine', '6809BatchFile', '');
    end
    else if SelectedFamily = '68hc11' then
    begin
      CommandLine := iniFile.ReadString('CommandLine', 'as11CommandLine', '% -o@.s19 -L@.lst -s');
      BatchFile := iniFile.ReadString('CommandLine', 'as11BatchFile', '');
    end
    else if SelectedFamily = '68hc12' then
    begin
      // "c:\6812\as12.exe" "test.asm" -o"Test.s19" -L"Test.lst"
      CommandLine := iniFile.ReadString('CommandLine', 'as12CommandLine', '% -o@.s19 -L@.lst -s');
      BatchFile := iniFile.ReadString('CommandLine', 'as12BatchFile', '');
    end;
    CommandLine := StringReplace(CommandLine, '%', Filename, [rfReplaceAll]);
    CommandLine := StringReplace(CommandLine, '@', FnameNoExt, [rfReplaceAll]);
    cmd := '"' + AssemblerPath + '" ' + CommandLine;

    DoSRecCvt := False;
    if (SRecCvtCmd > '') and (SelectedFamily = '68hc12') then
    begin
      if not FileExists(OurPath + 'sreccvt.exe') then
        MessageDlg('Error-you specified a cmdline for SRecCVT.exe, but it is not installed in same folder as AsmIDE', mtError, [mbOK], 0)
      else
        DoSRecCvt := True;
    end;

    Screen.Cursor := crHourglass;
    try
      RichEdit1.Lines.Clear;
      RichEdit1.Lines.Add('SelectedFamily: ' + SelectedFamily);
      RichEdit1.Lines.Add('Now assembling ' + Filename);
      msg := '';

      ReturnCode := ExecuteCombined(cmd, strlist1, ExitCode);
      PostMessage(RichEdit1.Handle, EM_SCROLLCARET, 0, 0); // scroll down
      case ReturnCode of
        ERR_STDOUT: msg := 'Error creating tempfile for stdout';
        ERR_STDERR: msg := 'Error creating tempfile for stderr';
      end;

      if (ReturnCode <> 0) and (ReturnCode < ERR_BASE) then
        // CreateProcess returned an error
        msg := SysErrorMessage(ReturnCode);
      if (msg <> '') or (ExitCode <> 0) or (not FileExists(ChangeFileExt(Filename, '.s19'))) then
        GoodAssembly := False;
      if (msg = '') then
        // the command ran - but the exitcode might be non-zero
        msg := 'Exitcode = ' + IntToStr(ExitCode);

      for i := 0 to Pred(StrList1.Count) do
      begin
        RichEdit1.Lines.Add(StrList1[i]);
      end;
      RichEdit1.Lines.Add(msg);
      PostMessage(RichEdit1.Handle, EM_SCROLLCARET, 0, 0); // scroll down

      msg2 := '';
      if DoSrecCvt and GoodAssembly then
      begin
        RichEdit1.Lines.Add('');
        RichEdit1.Lines.Add('Now running SRecCVT');
        cmd := '"' + OurPath + 'sreccvt.exe" ' + SRecCvtCmd + ' -o Tempxxx.s19 ' + ChangeFileExt(Filename, '.s19');
        RichEdit1.Lines.Add(cmd);
        ReturnCode := ExecuteCombined(cmd, Strlist2, ExitCode);
        PostMessage(RichEdit1.Handle, EM_SCROLLCARET, 0, 0); // scroll down
        case ReturnCode of
          ERR_STDOUT: msg2 := 'Error creating tempfile for stdout';
          ERR_STDERR: msg2 := 'Error creating tempfile for stderr';
        end;
        if (ReturnCode <> 0) and (ReturnCode < ERR_BASE) then
        begin
          // CreateProcess returned an error
          msg2 := SysErrorMessage(ReturnCode);
        end;
        if (msg2 <> '') or (ExitCode <> 0) or (not FileExists('Tempxxx.s19')) then
        begin
          GoodAssembly := False;
        end;

        if (msg2 = '') then
        begin
          // the command ran - but the exitcode might be non-zero
          msg2 := 'Exitcode = ' + IntToStr(ExitCode);
        end;
      end;

      for i := 0 to Pred(StrList2.Count) do
      begin
        RichEdit1.Lines.Add(StrList2[i]);
      end;
      RichEdit1.Lines.Add(msg2);
      PostMessage(RichEdit1.Handle, EM_SCROLLCARET, 0, 0); // scroll down

      if GoodAssembly and DoSRecCvt then
      begin
        RichEdit1.Lines.Add('');
        RichEdit1.Lines.Add('del ' + ChangeFileExt(Filename, '.s19'));
        DeleteFile(ChangeFileExt(Filename, '.s19'));
        RichEdit1.Lines.Add('ren Tempxxx.s19' + ChangeFileExt(Filename, '.s19'));
        RenameFile('Tempxxx.s19', ChangeFileExt(Filename, '.s19'));
      end;

      if GoodAssembly and (BatchFile > '') then
      begin
        // run the user's batch file
        if not FileExists(BatchFile) then
        begin
          MessageDlg('Can not find: ' + BatchFile + ' See View..Options..Assembler', mtError, [mbOK], 0);
          Exit;
        end;
        // sample batch file syntax:
        // C:\util\batch.bat myfile.asm  (start in c:\myappdir)

        RichEdit1.Lines.Add('');
        RichEdit1.Lines.Add('Running batch file: ' + BatchFile);
        PostMessage(RichEdit1.Handle, EM_SCROLLCARET, 0, 0); // scroll down

        // new way to launch batch file and wait for it to finish
        if not ExecAndWait(BatchFile + ' ' + Filename) then
          GoodAssembly := False;
      end;

      if FileExists(ChangeFileExt(Filename, '.lst')) then
        CreateListWindow(ChangeFileExt(Filename, '.lst'));

      // test bCallingFromDownload to ensure that we don't do the auto commands twice - he's
      // going to do it when we return
      if GoodAssembly and (SelectedFamily = '68hc12') and (not bCallingFromDownload) then
      begin
        PerformAutoCommands(ChangeFileExt(Filename, '.s19'));
      end;

    finally
      Screen.Cursor := crDefault;
      ChDir(OurPath);
    end;
  finally
    NowAssembling := False; // enable the Assemble Button
    StrList1.Free;
    StrList2.Free;
  end;
end;

// return true if the download was done, false otherwise.
// The result is only affected by AutoLoad.
// TODO: merge the download speedbutton download with the one we auto-do for the make button

function TMainForm.PerformAutoCommands(Filename: string): Boolean;
var
  FileStream: TFileStream;
  i: integer;
begin
  result := False;
  if SelectedFamily <> '68hc12' then
    Exit;

  EnableAutoLoad := iniFile.ReadBool('AutoFunctions', 'EnableLoad', True);
  EnableAutoGo := iniFile.ReadBool('AutoFunctions', 'EnableGo', True);
  EnableAutoDump := iniFile.ReadBool('AutoFunctions', 'EnableDump', True);

  if not (EnableAutoLoad or EnableAutoGo or EnableAutoDump) then
    Exit;

  if not GetAutoCommands then
    Exit; // syntax error

  if ((not EnableAutoLoad) and EnableAutoGo) and (fAutoGo > '') then
  begin
    // we don't want to auto-run the old downloaded code!
    MessageDlg('You have enabled AutoGo, but not AutoLoad. This is not valid - ' + #13 + #10 +
      'you must enable AutoLoad in order to use AutoGo. See Help,', mtError, [mbOK], 0);
    Exit;
  end;

  if EnableAutoLoad and (fAutoLoad > '') then
  begin
    RichEdit1.Lines.Add('');
    RichEdit1.Lines.Add('Performing AutoLoad');
    PostMessage(RichEdit1.Handle, EM_SCROLLCARET, 0, 0); // scroll down

    // handle special case downloads first
    if iniFile.ReadInteger('Download6812', 'option', 0) = 1 then
    begin
      PerformBinloadDownload(FileName);
      Result := True;
      Exit;
    end
    else if iniFile.ReadInteger('Download6812', 'option', 0) = 2 then
    begin
      PerformPlutoDownload(FileName);
      Result := True;
      Exit;
    end;

    // We're NOT using binload
    PageControl1.ActivePage := tsTerminal;
    if MonitorIsResponding then
    begin
      SendText(fAutoLoad + #13);

      FileStream := TFileStream.Create(Filename, fmOpenRead or fmShareDenyWrite);
      WriteStreamDone := False;
      AfDataDispatcher1.WriteStream(FileStream, True);

      for i := 1 to 3600 do // give up to 180 sec for D/L to complete
      begin
        sleep(50);
        Application.ProcessMessages;
        if WriteStreamDone then
          break; // end delay when the stream has been sent
      end;
      sleep(100); // a little extra delay to let the dispatcher cycle out
      Application.ProcessMessages;
      Result := True; // we downloaded the file
    end;

    if EnableAutoGo and (fAutoGo > '') then
    begin
      RichEdit1.Lines.Add('');
      RichEdit1.Lines.Add('Performing AutoGo');
      PostMessage(RichEdit1.Handle, EM_SCROLLCARET, 0, 0); // scroll down

      if MonitorIsResponding then
      begin
        RichEdit1.Lines.Add('');
        RichEdit1.Lines.Add('Waiting to perform AutoDump');
        WatchForAutoDump := True;
        SendText(fAutoGo + #13);
      end;
    end;

  end;
end;

// We require ;AsmIDE to start in col 1. We allow the other options in any order,
// and the dump commands can be continued on another line that begins with ;AsmIDE also.
// A sample comment that gives Auto commands:
// ;AsmIDE AutoLoad="load" AutoGo="g 2000" AutoDump="md 2000-2020" AutoDump="md 4020 4060"
// A result of true just means there was no syntax error - you have to examine these
// 3 items to determine if we found them:  fAutoLoad, fAutoGo, slAutoDump

function TMainForm.GetAutoCommands: boolean;
var
  s, stmp: string;
  i, idx: Integer;
begin
  // There's two global strings: fAutoLoad and fAutoGo
  // There's a global StringList: slAutoDump
  result := true;
  fAutoLoad := '';
  fAutoGo := '';
  slAutoDump.Clear;

  if fEditorForm <> nil then
  begin
    try
      for i := 0 to fEditorForm.GetLineCount - 1 do
      begin
        // in the interest of performance we'll only check the first 200 lines
        if i > 200 then
          break;

        s := UpperCase(fEditorForm.GetLine(i));

        if Copy(s, 1, 7) <> ';ASMIDE' then
          continue;

        idx := 8;
        while (idx < Length(s)) do
        begin
          stmp := Parse(s, 'AUTOLOAD=', idx);
          if stmp > '' then
          begin
            fAutoLoad := stmp;
            continue;
          end;

          if idx < length(s) then
          begin
            stmp := Parse(s, 'AUTOGO=', idx);
            if stmp > '' then
            begin
              fAutoGo := stmp;
              continue;
            end;
          end;

          // we don't allow more than 15 dump windows
          if (idx < length(s)) and (slAutoDump.Count < 15) then
          begin
            stmp := Parse(s, 'AUTODUMP=', idx);
            if stmp > '' then
            begin
              slAutoDump.Add(stmp);
              continue;
            end;
          end;

          Inc(idx);
        end;
      end;
    except
      MessageDlg('Error in AsmIDE Auto command: ' + s, mtError, [mbOK], 0);
      result := false;
    end;
  end;
end;

// Pass in a line of assembly source code. We assume that ";AsmIDE" has already
// been found in this line, and the initial value we get for ids already points
// past this value. Also pass in thr key value you want to look for. If we kind
// that key in the string we'll return the string value in the quotes for that key.
// If we find something, we'll incr the idx to point past the item we found.

function TMainForm.Parse(const s: string; const key: string; var idx: integer): string;
var
  s2: string;
  istrt, iend: Integer;
begin
  result := '';

  // We must find the key starting in the idx position. The caller keeps inc'ing
  // idx and calling us again until we've found everything.
  if Copy(s, idx, Length(Uppercase(key)) + 1) <> (Uppercase(key) + '"') then
    exit;

  istrt := idx + Length(key) + 1;
  s2 := Copy(s, istrt, Length(s) - istrt + 1);

  // find the end quote
  iend := Pos('"', s2);
  if iend = 0 then
  begin
    raise Exception.Create('bad syntax');
  end;
  result := Copy(s2, 1, iend - 1);
  idx := istrt + iend + 1;
end;

procedure TMainForm.actHelp6812Execute(Sender: TObject);
begin
  inherited;
  // the Help6812 form is auto-created
  Help6812.Show;
end;

procedure TMainForm.actDownloadExecute(Sender: TObject);
var
  FileStream: TFileStream;
  dlFileName: string;
begin
  if (SelectedFamily = '68hc12') then
  begin
    if iniFile.ReadInteger('Download6812', 'option', 0) = 0 then
      RichEdit1.Lines.Add('Download using d-bug12 "load"');
    if iniFile.ReadInteger('Download6812', 'option', 0) = 1 then
      RichEdit1.Lines.Add('Download using binload');
    if iniFile.ReadInteger('Download6812', 'option', 0) = 2 then
      RichEdit1.Lines.Add('Download using Pluto');
  end;
  // if not set to 6812, we are either using Buffalo or Wytec 6811

  if CommandsDataModule.actFileSave.Enabled then
  //if not CommandsDataModule.FileHasBeenSaved then
  begin
    if (CurrentFileName > '') and (iniFile.ReadBool('AutoFunctions', 'Autosave', True)) then
    begin
      Application.ProcessMessages;
      CommandsDataModule.MyFileSave;
    end
    else
    begin
      if Application.MessageBox('Do you want to save your changes first?', 'Save Changes',
        MB_YESNO + MB_DEFBUTTON1) = IDYES then
      begin
        CommandsDataModule.MyFileSaveAs;
        if Application.MessageBox('Do you want to assemble the file again?', 'Assemble Changes',
          MB_YESNO + MB_DEFBUTTON1) = IDYES then
        begin
          actAssembleExecute(self);
        end;
      end;
    end;
  end;

  if iniFile.ReadBool('AutoFunctions', 'AutoAssemble', True) then
  begin
    bCallingFromDownload := True;
    actAssembleExecute(self);
    bCallingFromDownload := False;
    if not GoodAssembly then
      Exit;
  end;

  if (CurrentFileName > '') then
  begin
    // default the filename, but let user change it
    if FileExists(ChangeFileExt(CurrentFilename, '.s19')) then
      OpenDialog1.Filename := ChangeFileExt(CurrentFilename, '.s19')
    else if FileExists(ChangeFileExt(CurrentFilename, '.hex')) then
      OpenDialog1.Filename := ChangeFileExt(CurrentFilename, '.hex');
    dlFileName := OpenDialog1.Filename;
  end
  else
    OpenDialog1.InitialDir := LastFolder;

  if (CurrentFileName = '') or (not iniFile.ReadBool('AutoFunctions', 'NoDownloadingFileNamePrompt', True)) then
  begin
    if OpenDialog1.Execute then
    begin
      dlFileName := OpenDialog1.Filename;
    end
    else
      Exit;
  end;

  if (SelectedFamily = '68hc12') then
  begin
    // handle special case downloads first
    if iniFile.ReadInteger('Download6812', 'option', 0) = 1 then
    begin
      PerformBinloadDownload(dlFileName);
      Exit;
    end
    else if iniFile.ReadInteger('Download6812', 'option', 0) = 2 then
    begin
      PerformPlutoDownload(dlFileName);
      Exit;
    end;
  end;

  // We're NOT using binload or pluto
  if not AfComPort1.Active then
  begin
    MessageDlg('Error - please configure your COM port in View..Options', mtError, [mbOK], 0);
    exit;
  end;

  if not PerformAutoCommands(dlFileName) then
  begin
    // SendBtn.Enabled := False;
    // AbortBtn.Enabled := True;
    PageControl1.ActivePage := tsTerminal;
    FileStream := TFileStream.Create(dlFileName, fmOpenRead or fmShareDenyWrite);

    NowDownloading := True; // disable the download button
    try
      AfDataDispatcher1.WriteStream(FileStream, True);
    finally
      // DO NOT DO THIS!!!!
      // FileStream.Free;
    end;
  end;

  PageControl1.ActivePage := tsTerminal;
  AfDataTerminal1.SetFocus; // won't be done if using binload / Pluto
end;

// Test to see if the monitor is listening for a command
// This shouldn't be called unless we're using the 68hc12

function TMainForm.MonitorIsResponding: Boolean;
var
  i: integer;
begin
  RichEdit1.Lines.Add('Testing to see if monitor is responding');
  Result := False;
  WatchForMonitorReady := True;

  // Send a CR (or CTRL-X for buffalo) thru the port, wait a short time for an answer, then
  // check to make sure we got the prompt: ">".
  {
  RichEdit1.Lines.Add('Selected Family = ' + SelectedFamily);
  if SelectedFamily = '68hc11' then
  begin
    // buffalo repeats the last command if you send it a CR!!!!!
    // TODO: I never got this to be reliable, so I'm not using it
    SendText(#24); // send a CTRL-X for Buffalo
  end
  else
  begin
  }
  SendText(#13);
  { end; }

  for i := 0 to 70 do
  begin
    if not WatchForMonitorReady then
      break;
    sleep(30);
    Application.Processmessages;
  end;
  if not WatchForMonitorReady then
  begin
    Result := True;
    RichEdit1.Lines.Add('monitor is responding');
  end;

  if not Result then
  begin
    MessageDlg('The monitor is not responding. Try to reset the board, and then do the download again.'
      + #13 + #10 + #13 + #10 + 'If you can''t make this work, then disable the AutoLoad option,'
      + #13 + #10 + 'or remove the AutoLoad comment.'
      + #13 + #10 + 'See the help topic: "Automatic Commands".', mtError, [mbOK], 0);
  end;
end;

procedure TMainForm.PerformBinloadDownload(Filename: string);
var
  BinloadCmd, msg: string;
  PortWasActive: Boolean;
  ReturnCode: DWORD;
  ExitCode: DWORD;
  i: Integer;
begin
  if not FileExists(OurPath + 'binload.exe') then
  begin
    MessageDlg('Can not find: ' + OurPath + 'binload.exe', mtError, [mbOK], 0);
    exit;
  end;

  if (BinloadAndPlutoPort < 1) or (BinloadAndPlutoPort > 2) then
  begin
    MessageDlg('Port: ' + IntToStr(BinloadAndPlutoPort) + ' can not be used by binload, only 1 and 2 are supported', mtError, [mbOK], 0);
    MessageDlg('Either correct your port under Options..Assembler, or try Pluto', mtError, [mbOK], 0);
    exit;
  end;

  for i := 1 to Length(filename) do
  begin
    if filename[i] = ' ' then
    begin
      MessageDlg('Sorry, binload doesn''t support spaces in folder or filenames: ' + filename, mtError, [mbOK], 0);
      exit;
    end;
  end;

  BinloadCmd := OurPath + 'binload.exe  /p ' + IntToStr(BinloadAndPlutoPort) + ' /r /e /l "' + Filename + '" /q';
  PortWasActive := AfComPort1.Active;
  if PortWasActive then
  begin
    AfComPort1.Close;
    if AfComPort1.Active then
      MessageDlg('Error closing port', mtError, [mbOK], 0);
  end;

  Screen.Cursor := crHourglass;
  try
    PageControl1.ActivePage := tsMessages;
    NowDownloading := True; // disable the download button
    RichEdit1.Lines.Clear;
    RichEdit1.Lines.Add('Now Downloading with binload');
    msg := '';
    ReturnCode := ExecuteCombined(BinloadCmd, RichEdit1.Lines, ExitCode);

    case ReturnCode of
      ERR_STDOUT: msg := 'Error creating tempfile for stdout';
      ERR_STDERR: msg := 'Error creating tempfile for stderr';
    end;
    if (ReturnCode <> 0) and (ReturnCode < ERR_BASE) then
      // CreateProcess returned an error
      msg := SysErrorMessage(ReturnCode);
    if (msg = '') then
      // the command ran - but the exitcode might be non-zero
      msg := 'Exitcode = ' + IntToStr(ExitCode);
    RichEdit1.Lines.Add(msg);
    if ExitCode <> 0 then
      RichEdit1.Lines.Add('Maybe you forgot to put switch in boot, and reset board?');
    PostMessage(RichEdit1.Handle, EM_SCROLLCARET, 0, 0); // scroll down

    if PortWasActive then
    begin
      AfComPort1.Open;
    end;
  finally
    Screen.Cursor := crDefault;
    NowDownloading := False; // enable the download button
  end;
end;

procedure TMainForm.PerformPlutoDownload(Filename: string);
var
  Cmd: string;
  PlutoIniFile: TIniFile;

  { function IsPlutoRunning: boolean;
  var
    myHandle: HWND;
  begin
    myHandle := FindWindow('Pluto Debugger', nil);
    if myHandle <> 0 then
      result := true
    else
      result := false;
  end;
  }

  // This uses the Win32 process list, instead of the simpler FindWindow. This allows
  // Pluto to change the window caption to include the filename.
  function IsPlutoRunning: Boolean;
  var
    MyHandle: THandle;
    Struct: TProcessEntry32;
    PgmName: string;
    Buff: PChar;
  begin
    GetMem(Buff, 256);
    Result := False;
    try
      MyHandle := CreateToolHelp32SnapShot(TH32CS_SNAPPROCESS, 0);
      Struct.dwSize := Sizeof(TProcessEntry32);
      if Process32First(MyHandle, Struct) then
      begin
        strcopy(buff, Struct.szExeFile);
        PgmName := lowercase(buff);
        if (PgmName = 'pluto.exe') then
        begin
          result := true;
          exit;
        end;
        while Process32Next(MyHandle, Struct) do
        begin
          strcopy(buff, Struct.szExeFile);
          PgmName := lowercase(buff);
          if (PgmName = 'pluto.exe') then
          begin
            result := true;
            exit;
          end;
        end;
      end;
    except
      on E: exception do
        MessageDlg('Error getting process list', mtError, [mbOK], 0);
    end
  end;

begin
  if not FileExists(OurPath + 'pluto.exe') then
  begin
    MessageDlg('Can not find: ' + OurPath + 'pluto.exe', mtError, [mbOK], 0);
    exit;
  end;

  // TODO: not sure what port numbers Pluto can use?
  if (BinloadAndPlutoPort < 1) then
  begin
    MessageDlg('Bad Port for Pluto: Correct your port under Options..Assembler', mtError, [mbOK], 0);
    exit;
  end;

  if AfComPort1.Active then
  begin
    // should not happen
    MessageDlg('AsmIDE COM port is active, it must be disabled in order to use Pluto', mtError, [mbOK], 0);
    Exit;
  end;

  // If Pluto is active, it has a watch on this INI file, and it will pop up and open this file.
  PlutoIniFile := TIniFile.Create(OurPath + 'pluto-autoload.ini');
  // Pluto opens .lst files
  PlutoIniFile.WriteString('Autoload', 'Filename', ChangeFileExt(Filename, '.lst'));
  PlutoIniFile.Free;

  Screen.Cursor := crHourglass;
  try
    PageControl1.ActivePage := tsMessages;
    NowDownloading := True; // disable the download button
    RichEdit1.Lines.Clear;
    RichEdit1.Lines.Add('Now Starting Pluto');
    Cmd := OurPath + 'pluto.exe';

    // We won't test to see if Pluto is running, but we'll just launch anyway.
    // If it's already running it will bring the other instance to the foreground and exit.
   // if not IsPlutoRunning then
   // begin
      // This starts Pluto, but does not wait for it to complete. We want the user to be able to switch between AsmIDE and Pluto.
    ShellExecute(Application.MainForm.Handle, 'open', PChar(Cmd), nil, nil, SW_SHOWNORMAL);
   // end;
  finally
    Screen.Cursor := crDefault;
    NowDownloading := False; // enable the download button
  end;
end;

// This will combine both stdout and stderr into the same memo

function TMainForm.ExecuteCombined(CommandLine: string; strCombinedOut: TStrings; var ExitCode: DWORD): DWORD;
var
  CombinedOut_File: string;
  ReturnBool: Boolean;
  pCommandLine: array[0..MAX_PATH] of char;
  pCombinedOut_File: array[0..MAX_PATH] of char;
  StartupInfo: TStartupInfo;
  ProcessInfo: TProcessInformation;
  SecAtrrs: TSecurityAttributes;
  hAppProcess, hAppThread, hCombinedOut_File, hStderr_Dupe: THandle;
  tmpPath, tmpPrefix: string;
  tmpFileNameAry, tmpPathAry: array[0..MAX_PATH + 1] of char;
begin
  strCombinedOut.Clear;

  // Get the Windows temp dir:
  GetTempPath(255, @tmpPathAry);
  tmpPath := StrPas(tmpPathAry);

  tmpPrefix := '~EE';
  // This Windows call will create a unique temp file name.
  // We have to specify 0 for the third parameter in order to ensure a
  // unique filename.
  GetTempFileName(PChar(tmpPath), PChar(tmpPrefix), 0, tmpFileNameAry);
  CombinedOut_File := StrPas(tmpFileNameAry); // convert from char array to string

  hCombinedOut_File := 0;
  hStderr_Dupe := 0;
  hAppProcess := 0;
  hAppThread := 0;

  { copy the parameter Pascal strings to null terminated strings }
  StrPCopy(pCommandLine, CommandLine);
  StrPCopy(pCombinedOut_File, CombinedOut_File);

  try
    { Prepare SecAttrs structure for the CreateFile call.
      This SecAttrs structure is needed because we want the
      returned handle to be inherited by a child process.
    }
    FillChar(SecAtrrs, SizeOf(SecAtrrs), #0);
    SecAtrrs.nLength := SizeOf(SecAtrrs);
    SecAtrrs.lpSecurityDescriptor := nil;
    SecAtrrs.bInheritHandle := True; { this is what we need here }

    { create the appropriate handle for the CombinedOut file }
    hCombinedOut_File := CreateFile(pCombinedOut_File, { pointer to name of the file }
      GENERIC_READ or GENERIC_WRITE, { access (read-write) mode }
      FILE_SHARE_READ or FILE_SHARE_WRITE, { share mode }
      @SecAtrrs, { pointer to security attributes }
      CREATE_ALWAYS, { how to create }
      FILE_ATTRIBUTE_NORMAL, { file attributes }
      0); { handle to file with attributes to copy }

    { is hCombinedOut_File a valid handle? }
    if hCombinedOut_File = INVALID_HANDLE_VALUE then
    begin
      Result := ERR_STDOUT; // Bad creation of CombinedOut File
      Exit;
    end;

    { Duplicate the handle so we can use it for both stdout and stderr }
    if not DuplicateHandle(GetCurrentProcess(), hCombinedOut_File, GetCurrentProcess(),
      @hStderr_Dupe, 0, true, DUPLICATE_SAME_ACCESS) then
    begin
      Result := ERR_STDERR; // Bad creation of dupe handle
      Exit;
    end;

    { prepare StartupInfo structure }
    FillChar(StartupInfo, SizeOf(StartupInfo), #0);
    StartupInfo.cb := SizeOf(StartupInfo);
    StartupInfo.dwFlags := STARTF_USESHOWWINDOW or STARTF_USESTDHANDLES;
    StartupInfo.wShowWindow := SW_HIDE; // do not show the cmd window

    // Assign CombinedOut and Stderr
    StartupInfo.hStdoutput := hCombinedOut_File;
    StartupInfo.hStderror := hStderr_Dupe;

    { Create the application as a process running in a thread, and start it. }
    { "CreateProcess" returns a Boolean Value. If it fails, you are supposed }
    { to call "GetLastError" to determine what went wrong. I've found that }
    { "GetLastError" often returns code 2 (last operation was successful) even }
    { if "CreateProcess" fails. }
    ReturnBool := CreateProcess(nil, { pointer to name of executable module }
      pCommandLine, { pointer to command line string }
      nil, { pointer to process security attributes }
      nil, { pointer to thread security attributes }
      True, { inheritance flag - important! }
      CREATE_NEW_CONSOLE or NORMAL_PRIORITY_CLASS, { creation flags }
      nil, { pointer to new environment block }
      nil, { pointer to current directory name }
      StartupInfo, { pointer to STARTUPINFO }
      ProcessInfo); { pointer to PROCESS_INF }

    if ReturnBool then
    begin
      { wait for the app to finish its job and save the handles to free them later }
      WaitforSingleObject(ProcessInfo.hProcess, INFINITE);
      hAppProcess := ProcessInfo.hProcess;
      hAppThread := ProcessInfo.hThread;
      // An exit code of 0 means no error. If it's non-zero, then it represents
      // a program-specific error code.
      GetExitCodeProcess(hAppProcess, ExitCode);
      Result := 0; // no error (but we might have a bad exitcode from the command)
    end
    else
    begin
      // GetLastError can NOT be used on an exit code - it's only helpful if
      // the CreateProcess failed
      Result := GetLastError;
    end;

  finally
    { close the handles
      Kernel objects, like the process and the files we created in this case,
      are maintained by a usage count.
      So, for cleaning up purposes we have to close the handles
      to inform the system that we don't need the objects anymore.
      IMPORTANT! If they are 0, then they have already been closed! }
    if hCombinedOut_File <> 0 then
      CloseHandle(hCombinedOut_File);
    if hStderr_Dupe <> 0 then
      CloseHandle(hStderr_Dupe);
    if hAppThread <> 0 then
      CloseHandle(hAppThread);
    if hAppProcess <> 0 then
      CloseHandle(hAppProcess);
  end;

  application.processmessages;
  try
    strCombinedOut.LoadFromFile(CombinedOut_File);
  except
    // ignore error if there are too many lines
  end;
  DeleteFile(CombinedOut_File);
end;

procedure TMainForm.actHelpAssemExecute(Sender: TObject);
begin
  if SelectedFamily = '6808' then
    HelpFilePath := iniFile.ReadString('Assembler', '6808HelpPath', '')
  else if SelectedFamily = '6809' then
    HelpFilePath := iniFile.ReadString('Assembler', '6809HelpPath', '')
  else if SelectedFamily = '68hc11' then
    HelpFilePath := iniFile.ReadString('Assembler', 'hc11HelpPath', '')
  else if SelectedFamily = '68hc12' then
    HelpFilePath := iniFile.ReadString('Assembler', 'hc12HelpPath', '');

  if not FileExists(HelpFilePath) then
  begin
    MessageDlg('Can not find the Help file - Please check View..Options'
      + #13#10 + HelpFilePath, mtError, [mbOK], 0);
    exit;
  end;
  ShellExecute(Application.MainForm.Handle, 'open', PChar(HelpFilePath), nil, nil, SW_SHOWNORMAL);
end;

procedure TMainForm.actAssembleUpdate(Sender: TObject);
begin
  actAssemble.Enabled := (not NowAssembling);
end;

procedure TMainForm.actDownloadUpdate(Sender: TObject);
begin
  actDownload.Enabled := (not NowDownloading);
  if actDownload.Enabled then
  begin
    Download1.Visible := True;
    DownloadSeparator1.Visible := True;
    tbDownload.Visible := True;
  end
  else
  begin
    Download1.Visible := False;
    DownloadSeparator1.Visible := False;
    tbDownload.Visible := False;
  end;
end;

procedure TMainForm.AfDataDispatcher1WriteStreamDone(Sender: TObject);
begin
  // notify the main UI thread that we are done sending a stream
  // (a .s19 download is done)
  SendMessage(self.Handle, WM_WRITE_STREAM_DONE_MESSAGE, 1, 0);
end;

procedure TMainForm.actHelpAboutExecute(Sender: TObject);
var
  AboutBox: TAboutBox;
begin
  AboutBox := TAboutBox.Create(self);
  try
    AboutBox.ShowModal;
  finally
    AboutBox.Free;
  end;
end;

procedure TMainForm.actWytecToolsUpdate(Sender: TObject);
begin
  if WytecEnabled then
  begin
    actWytecTools.Enabled := True;
    actWytecTools.Visible := True;

    tbWytecSeparator.Visible := True;
    tbWytec.Visible := True;

    Wytec1.Visible := True;
    WytecSeparator1.Visible := True;
  end
  else
  begin
    actWytecTools.Enabled := False;
    actWytecTools.Visible := False;

    tbWytecSeparator.Visible := False; // this doesn't seem to work
    tbWytec.Visible := False;

    Wytec1.Visible := False;
    WytecSeparator1.Visible := False;
  end;
end;

procedure TMainForm.actWytecToolsExecute(Sender: TObject);
begin
  // the frmWytec form is auto-created
  if not FileExists(WytecDebuggerPath) then
  begin
    MessageDlg('Can not find Wytec debugger file: ' + WytecDebuggerPath + '  Please check View..Options', mtWarning, [mbOK], 0);
    Exit;
  end;
  if CurrentFilename > '' then
    frmWytec.WytecFilename := ChangeFileExt(CurrentFilename, '.s19')
  else
    frmWytec.WytecFilename := '';
  frmWytec.ShowModal;
end;

procedure TMainForm.Splitter1Moved(Sender: TObject);
begin
  if PageControl1.Height < 20 then
    PageControl1.Height := 20;
  StatusBar.Top := PageControl1.Height + PageControl1.Top;
end;

function ExecuteFile(const FileName, Params, DefaultDir: string;
  ShowCmd: Integer): THandle;
var
  zFileName, zParams, zDir: array[0..132] of Char;
begin
  Result := ShellExecute(Application.MainForm.Handle, nil,
    StrPCopy(zFileName, FileName), StrPCopy(zParams, Params),
    StrPCopy(zDir, DefaultDir), ShowCmd);
end;

procedure TMainForm.actHelpMainExecute(Sender: TObject);
begin
  ShellExecute(Application.MainForm.Handle, 'open', PChar(Application.HelpFile), nil, nil, SW_SHOWNORMAL);
  //Application.HelpCommand(HELP_FINDER, 0); //show Contents window
  // Application.HelpCommand(HELP_CONTENTS, 0);
end;

procedure TMainForm.TerminalClearPopItemClick(Sender: TObject);
begin
  AfDataTerminal1.ClearBuffer;
end;

procedure TMainForm.TerminalCopyPopItemClick(Sender: TObject);
var
  i, highest: integer;
  s: string;
begin
  highest := AfDataTerminal1.BufferLineNumber;
  for i := 1 to highest do
    s := s + AfDataTerminal1.BufferLine[i] + #13#10;
  ClipBoard.AsText := s;
end;

procedure TMainForm.TerminalPastePopItemClick(Sender: TObject);
begin
  SendText(Clipboard.AsText);
end;

procedure TMainForm.TerminalLogOnPopItemClick(Sender: TObject);
begin
  TerminalLogOpenDialog.InitialDir := IniFile.ReadString('Options', 'LogDir', 'C:\');
  if TerminalLogOpenDialog.Execute then
  begin
    IniFile.WriteString('Options', 'LogDir', ExtractFilePath(TerminalLogOpenDialog.Filename));
    AfDataTerminal1.LogName := TerminalLogOpenDialog.Filename;
    AfDataTerminal1.LogFlushTime := 3000; // write to log every 3 secs
    AfDataTerminal1.Logging := lgAppend; // this turns on the log
  end;
end;

procedure TMainForm.TerminalLogOffPopItemClick(Sender: TObject);
begin
  AfDataTerminal1.Logging := lgOff;
end;

procedure TMainForm.ClearPopItemClick(Sender: TObject);
begin
  RichEdit1.Lines.Clear;
end;

procedure TMainForm.CopyPopItemClick(Sender: TObject);
var
  s: string;
begin
  s := RichEdit1.SelText;
  // Fix the line terminators:
  s := StringReplace(s, #31#10, '', [rfReplaceAll]);
  // Copy the text to clipboard:
  Clipboard.AsText := s;
end;

procedure TMainForm.TerminalPopupPopup(Sender: TObject);
begin
  if ClipBoard.AsText > '' then
    TerminalPastePopItem.Enabled := True
  else
    TerminalPastePopItem.Enabled := False;
  if AfDataTerminal1.Logging = lgOff then
  begin
    TerminalLogOnPopItem.Enabled := True;
    TerminalLogOffPopItem.Enabled := False;
  end
  else
  begin
    TerminalLogOnPopItem.Enabled := False;
    TerminalLogOffPopItem.Enabled := True;
  end;
end;

procedure TMainForm.AfDataTerminal1KeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (F2String > '') and (Key = VK_F2) then
  begin
    SendText(F2String);
    Key := 0;
  end;
  if (F3String > '') and (Key = VK_F3) then
  begin
    SendText(F3String);
    Key := 0;
  end;
  if (F4String > '') and (Key = VK_F4) then
  begin
    SendText(F4String);
    Key := 0;
  end;
  if (F5String > '') and (Key = VK_F5) then
  begin
    SendText(F5String);
    Key := 0;
  end;
  if (F6String > '') and (Key = VK_F6) then
  begin
    SendText(F6String);
    Key := 0;
  end;
  if (F7String > '') and (Key = VK_F7) then
  begin
    SendText(F7String);
    Key := 0;
  end;
  if (F8String > '') and (Key = VK_F8) then
  begin
    SendText(F8String);
    Key := 0;
  end;
  if (F9String > '') and (Key = VK_F9) then
  begin
    SendText(F9String);
    Key := 0;
  end;
  if (F10String > '') and (Key = VK_F10) then
  begin
    SendText(F10String);
    Key := 0;
  end;
  if (F11String > '') and (Key = VK_F11) then
  begin
    SendText(F11String);
    Key := 0;
  end;
  if (F12String > '') and (Key = VK_F12) then
  begin
    SendText(F12String);
    Key := 0;
  end;
end;

// old legacy code

procedure TMainForm.SendToTerminal(s: string);
var
  memStream: TMemoryStream;
begin
  // EWE: This just sends string to the screen, not the com port
  //AfDataTerminal1.WriteString(Clipboard.AsText);
  //AfDataTerminal1.DrawChangedBuffer;

  MemStream := TMemoryStream.Create;
  MemStream.WriteBuffer(Pointer(s)^, Length(s));
  // Go back to the start of the stream
  MemStream.Position := 0;

  try
    AfDataDispatcher1.WriteStream(MemStream, True);
  finally
    // DO NOT DO THIS!!!!
    // MemStream.Free;
  end;
end;

// EWE: new version of SendToTerminal

procedure TMainForm.SendText(s: string);
var
  i: integer;
begin
  AfComPort1.WriteString(s);
//  SendToTerminal(s); // EWE test
  for i := 1 to 5 do
  begin
    Application.ProcessMessages;
    Sleep(30);
  end;
end;

// This is the new COM Object method of calling a batch file and waiting
// for it to return. This also detects the return code, and returns false
// if the return code was non-zero. I'm not sure if this works on Win98?

function TMainForm.ExecAndWait(const CommandLine: string): boolean;
var
  WScript: OleVariant;
  RetCode: integer;
  s: string;
begin
  try
    WScript := CreateOleObject('WScript.Shell');
    try
      // A 0 for the second parameter tells it to hide the new window.
      // A 1 for the third parameter says we want it to wait until the command
      //   is finished before returning.
      RetCode := WScript.run(CommandLine, 0, 1);
    finally
      WScript := UnAssigned;
    end;

    if RetCode <> 0 then
      raise Exception.Create('Bad Return Code: ' + IntToStr(RetCode));

    result := True;
  except
    on E: Exception do
    begin
      result := False;
      s := E.Message + ' from: ' + CommandLine;
      MessageDlg(s, mtError, [mbOK], 0);
    end;
  end;
end;

// A manual dump - requires autodump commands in source code

procedure TMainForm.actDumpMemoryExecute(Sender: TObject);
begin
  if not (EnableCOMPort and (AfComPort1.ComNumber > 0) and afDataTerminal1.Enabled) then
  begin
    MessageDlg('ComPort not active - can not perform dumps', mtError, [mbOK], 0);
    Exit;
  end;

  if (SelectedFamily = '68hc12') then
  begin
    // TODO: workout Pluto dumps - turn into Watches
    if iniFile.ReadInteger('Download6812', 'option', 0) = 1 then
      MessageDlg('Binload is enabled - can not perform dumps with serial monitor', mtError, [mbOK], 0);
  end;

  PerformDumps;
end;

// This performs all dumps specified by source code. This is called for both manual
// and auto dumps.
// If this is a manually-requested dump, we still have to find the dump commands
// in the source code, and they still say "AutoDump", even though the user may
// have disabled the AutoDump feature in the Options menu.

function TMainForm.PerformDumps: Boolean;
var
  i: integer;
begin
  result := False;
  if not (EnableCOMPort and (AfComPort1.ComNumber > 0) and afDataTerminal1.Enabled) then
  begin
    RichEdit1.Lines.Add('ComPort not active - can not perform dumps');
    Exit;
  end;

  RichEdit1.Lines.Add('Performing Dumps Now');

  WatchForAutoDump := False; // we don't want to keep looking for an autodump

  // make sure anything coming in now is done being pumped to terminal window
  for i := 0 to 10 do
  begin
    sleep(30);
    application.processmessages;
  end;

  CloseAllDumpWindows;

  if GetAutoCommands and (slAutoDump.Count > 0) then
  begin
    try
      PageControl1.ActivePage := tsTerminal;

      if not MonitorIsResponding then
      begin
        MessageDlg('Monitor is not responding', mtError, [mbOK], 0);
        Exit;
      end;
      PerformRegisterDump; // do this one time, and save the data in RegisterDumpData

      // Do all of the dumps requested in the source code AutoDump commands.
      for i := 0 to slAutoDump.Count - 1 do
      begin
        // Create a tabsheet, and give it a caption the command
        CreateDumpWindow(slAutoDump[i]);
        // Pass the actual dump command, and the index of the tabsheet
        PerformDump(slAutoDump[i], i);
      end;
    except
      //
    end;
    result := True;
    RichEdit1.Lines.Add('Done Performing Dumps');
  end
  else
    RichEdit1.Lines.Add('no dump specified in .asm file');
end;

// We'll do this one time, and insert the same register data into each tabsheet.
// The idea is that I think it may be helpful to see the register data when
// examining a dump of a memory range.

procedure TMainForm.PerformRegisterDump;
var
  sAll: string;
  i: integer;
begin
  sAll := '';
  try
    AnyDataLastStringReceived := '';
    WatchForAnyData := True;
    if SelectedFamily = '68hc11' then
    begin
      // update - a CR or CTRL-X following RM might terminate it?
      WatchForAnyData := false;

      // buffalo does not have a register dump command, so we have to send the
      // interactive register modify command and then cancel it.
      SendText('rm' + #13);
      // give it time to dump the registers, then cancel the interactive rm command
      for i := 0 to 10 do
      begin
        sleep(25);
        Application.ProcessMessages;
      end;
      WatchForAnyData := True;
      SendText(#24#13); // cancel with CTRL-X
    end
    else
    begin
      // d-bug12 had the Register Dump Command - much nicer!
      SendText('rd' + #13);
    end;

    while WatchForAnyData do
    begin
      // we have to spin the message loop so we can read more incoming text
      for i := 0 to 10 do
      begin
        sleep(25);
        Application.ProcessMessages;
      end;
    end;

    RegisterDumpData := AnyDataLastStringReceived;
  except
    //
  end;
end;

// Do one dump of a memory range. We are passed the actual dump command, and
// the index of the tabsheet we need to update.

procedure TMainForm.PerformDump(cmd: string; itab: integer);
var
  sAll: string;
  i: integer;
begin
  sAll := '';
  try
    DumpRegisterMemoAry[itab].Lines.Clear;
    DumpRegisterMemoAry[itab].Lines.add(RegisterDumpData);
    // delete first 2 lines
    DumpRegisterMemoAry[itab].Lines.Delete(0);
    DumpRegisterMemoAry[itab].Lines.Delete(0);
    // delete the prompt on last line, and the extra line of data we always get with rd
    DumpRegisterMemoAry[itab].Lines.Delete(DumpRegisterMemoAry[itab].Lines.Count - 1);
    DumpRegisterMemoAry[itab].Lines.Delete(DumpRegisterMemoAry[itab].Lines.Count - 1);

    AnyDataLastStringReceived := '';
    WatchForAnyData := True;
    SendText(cmd + #13);
    while WatchForAnyData do
    begin
      // we have to spin the message loop so we can read more incoming text
      for i := 0 to 10 do
      begin
        sleep(25);
        Application.ProcessMessages;
      end;
    end;

    DumpMemoryMemoAry[itab].Lines.Clear;
    // Add the combined dump data to the appropriate memo
    DumpMemoryMemoAry[itab].Lines.add(AnyDataLastStringReceived);
    // delete first 2 lines
    DumpMemoryMemoAry[itab].Lines.Delete(0);
    DumpMemoryMemoAry[itab].Lines.Delete(0);
    // delete the prompt on last line
    DumpMemoryMemoAry[itab].Lines.Delete(DumpMemoryMemoAry[itab].Lines.Count - 1);
  except
    //
  end;
end;

procedure TMainForm.CloseAllDumpWindows;
var
  i: integer;
begin
  PageControl2.ActivePageIndex := 0;
  // leave tab 0 open   UPD: in this case, the 0th Dump window is NOT overall tab window 0
  for i := Pred(DumpTabSheetCount) downto 0 do
  begin
    FreeAndNil(DumpTabSheetAry[i]);
    // the memory for all the controls on each tab should be auto-freed because
    // the tabsheet was specified as the owner of those controls
  end;
  DumpTabSheetCount := 0;
end;

procedure TMainForm.CreateDumpWindow(aCaption: string);
begin
  if DumpTabSheetCount = 15 then
    exit; // we don't allow more than 15 dump windows

  //if MainSheet = nil then
  //  MainSheet := PageControl2.ActivePage;

  DumpTabSheetAry[DumpTabSheetCount] := TTabSheet.Create(self);
  DumpTabSheetAry[DumpTabSheetCount].Caption := aCaption; // caption is the memory dump command
  DumpTabSheetAry[DumpTabSheetCount].Visible := True;
  DumpTabSheetAry[DumpTabSheetCount].PageControl := PageControl2;

  DumpLabel1Ary[DumpTabSheetCount] := TLabel.Create(DumpTabSheetAry[DumpTabSheetCount]);
  with DumpLabel1Ary[DumpTabSheetCount] do
  begin
    Parent := DumpTabSheetAry[DumpTabSheetCount];
    Caption := 'Register Dump:';
    Left := 20;
    Top := 10;
    Width := 76;
    Height := 13;
  end;

  DumpLabel2Ary[DumpTabSheetCount] := TLabel.Create(DumpTabSheetAry[DumpTabSheetCount]);
  with DumpLabel2Ary[DumpTabSheetCount] do
  begin
    Parent := DumpTabSheetAry[DumpTabSheetCount];
    Caption := 'Memory Dump:';
    Left := 20;
    Top := 84;
    Width := 74;
    Height := 13;
  end;

  DumpRangeLabelAry[DumpTabSheetCount] := TLabel.Create(DumpTabSheetAry[DumpTabSheetCount]);
  with DumpRangeLabelAry[DumpTabSheetCount] do
  begin
    Parent := DumpTabSheetAry[DumpTabSheetCount];
    Caption := aCaption;
    Left := 104;
    Top := 84;
    Width := 84;
    Height := 16;
    Font.Style := [fsBold];
  end;

  DumpRegisterMemoAry[DumpTabSheetCount] := TMemo.Create(DumpTabSheetAry[DumpTabSheetCount]);
  with DumpRegisterMemoAry[DumpTabSheetCount] do
  begin
    Parent := DumpTabSheetAry[DumpTabSheetCount];
    Left := 20;
    Top := 30;
    Width := RichEdit1.Width - 40;
    Height := 39;
    Anchors := [akLeft, akTop, akRight];
    ScrollBars := ssVertical;
    Font.Name := 'Courier New';
    TabOrder := 1;
    Text := 'Performing dump now ...';
  end;

  DumpMemoryMemoAry[DumpTabSheetCount] := TMemo.Create(DumpTabSheetAry[DumpTabSheetCount]);
  with DumpMemoryMemoAry[DumpTabSheetCount] do
  begin
    Parent := DumpTabSheetAry[DumpTabSheetCount];
    Left := 20;
    Top := 104;
    Width := RichEdit1.Width - 40;
    Height := PageControl2.Height - 148;
    Anchors := [akLeft, akTop, akRight, akBottom];
    ScrollBars := ssVertical;
    Font.Name := 'Courier New';
    TabOrder := 0;
    Text := 'Performing dump now ...';
  end;

  // Due to a bug in the PageControl, if we want to stay on our original page we
  // have to switch to another page, then back to our original page.
  PageControl2.ActivePage := DumpTabSheetAry[DumpTabSheetCount];
  PageControl2.ActivePageIndex := 0; // select main sheet
  Inc(DumpTabSheetCount);
end;

procedure TMainForm.CreateListWindow(aFilename: string);
//var
//  fMemo: TMemo;
begin
  CloseListWindow;
{
  fListSheet := TTabSheet.Create(self);
  fListSheet.Caption := aFilename;
  fListSheet.Visible := True;
  fListSheet.PageControl := PageControl2;

  fMemo:=TMemo.Create(fListSheet);
  fMemo.Parent:=fListSheet;
  fMemo.ReadOnly:=True;
  fMemo.Align:=alClient;
  fMemo.Lines.LoadFromFile(aFileName);
  fMemo.Scrollbars:= ssBoth;
 }
  ListEditor := GI_EditorFactory.CreateTabSheet(PageControl2);
  ;
  ListEditor.OpenFileReadOnly(AFileName);

  // Due to a bug in the PageControl, if we want to stay on our original page we
  // have to switch to another page, then back to our original page.
  PageControl2.ActivePage := fListSheet;
  PageControl2.ActivePageIndex := 0; // select main sheet
end;

procedure TMainForm.actPrintDumpsExecute(Sender: TObject);
var
  i, itab: integer;
begin
  if DumpTabSheetCount = 0 then
  begin
    MessageDlg('There are no memory dump Windows open', mtError, [mbOK], 0);
    Exit;
  end;

  rtfPrint := TRichEdit.Create(self);
  try
    rtfPrint.Parent := Self;
    rtfPrint.Visible := False;
    AddPrintLine('AsmIDE Memory Dumps     ' + FormatDateTime('mm/dd/yyyy hh:mm', Now), 16, True);
    AddPrintLine('', 16, True);

    // We only print the register dump for the first dump: memo index 0
    AddPrintLine('Register Dump', 12, True);
    for i := 0 to DumpRegisterMemoAry[0].Lines.Count - 1 do
      AddPrintLine(DumpRegisterMemoAry[0].Lines[i], 10, False);

    for itab := 0 to DumpTabSheetCount - 1 do
    begin
      AddPrintLine('', 16, True);
      AddPrintLine(DumpTabSheetAry[itab].Caption, 12, True); // caption is the memory dump command
      for i := 0 to DumpMemoryMemoAry[itab].Lines.Count - 1 do
        AddPrintLine(DumpMemoryMemoAry[itab].Lines[i], 10, False);
    end;

    rtfPrint.Print('MemoryDumps');
  finally
    rtfPrint.Free;
  end;
end;

procedure TMainForm.AddPrintLine(s: string; FontSize: integer; Bold: Boolean);
begin
  rtfPrint.SelAttributes.Name := 'Courier New';
  rtfPrint.SelAttributes.Size := FontSize;
  if Bold then
    rtfPrint.SelAttributes.Style := [fsBold]
  else
    rtfPrint.SelAttributes.Style := [];
  rtfPrint.Lines.Add(s);
end;

procedure TMainForm.AfDataDispatcher1DataReceived(Sender: TObject);
begin
  // the docs say we must read the data in this event handler, or we may miss some data.
  // But we can't interact with any other global items because we are on a background
  // thread, so we need to send the data to our main thread in a message.
  IncomingData := AfDataDispatcher1.ReadString;
  SendMessage(MainForm.Handle, WM_DATA_RECEIVED_MESSAGE, Integer(PChar(IncomingData)), 0);
end;

procedure TMainForm.actHyperBaudExecute(Sender: TObject);
var
  i: integer;
begin
  if InHyperBaud then
  begin
    // user wants to come out of Hyperbaud
    afComPort1.BaudRate := br9600;
    InHyperBaud := False;
    SendText(#13);
    SendText(#13);
    exit;
  end;
  // user wants to go into Hyperbaud
  SendText('baud 57600' + #13);
  for i := 1 to 30 do
  begin
    Application.ProcessMessages;
    Sleep(30);
  end;
  afComPort1.BaudRate := br57600;
  InHyperBaud := True;
  SendText(#13);
  SendText(#13);
  if not MonitorIsResponding then
  begin
    MessageDlg('Monitor is not responding', mtError, [mbOK], 0);
    Exit;
  end;
end;

procedure TMainForm.actlStandardUpdate(Action: TBasicAction;
  var Handled: Boolean);
begin
  // This is needed bec. Delphi's action updates on individual actions
  // don't always fire when we think they should.
  actDumpMemoryUpdate(self);
  actHyperBaudUpdate(self);
  actWytecToolsUpdate(self);
end;

{
procedure TMainForm.TryTest(t, s: string);
var
  i: integer;
  sd: string;
begin
  MonitorLastStringReceived := '';

  WatchForMonitorReady := True;

  // buffalo repeats the last command if you send it a CR!!!!!
  SendText(s);

  for i := 0 to 50 do
  begin
    if not WatchForMonitorReady then
      break;
    sleep(30);
    Application.Processmessages;
  end;

  sd := '';
  i := Length(MonitorLastStringReceived);
  if (i > 4) then
  begin
    sd := sd + ' ' + IntToHex(Ord(MonitorLastStringReceived[i - 4]), 2);
  end;
  if (i > 3) then
  begin
    sd := sd + ' ' + IntToHex(Ord(MonitorLastStringReceived[i - 3]), 2);
  end;
  if (i > 2) then
  begin
    sd := sd + ' ' + IntToHex(Ord(MonitorLastStringReceived[i - 2]), 2);
  end;
  if (i > 1) then
  begin
    sd := sd + ' ' + IntToHex(Ord(MonitorLastStringReceived[i - 1]), 2);
  end;
  if (i > 0) then
  begin
    sd := sd + ' ' + IntToHex(Ord(MonitorLastStringReceived[i]), 2);
  end;

  if not WatchForMonitorReady then
    ShowMessage('it works - monitor is responding, test: ' + t)
  else
  begin
    ShowMessage('monitor is NOT responding, test=' + t + ',  strlen=' + IntToStr(i) + ' data: ' + sd);
  end;
end;
}

procedure TMainForm.actDumpMemoryUpdate(Sender: TObject);
begin
  if (SelectedFamily = '68hc12') and EnableCOMPort and (iniFile.ReadInteger('Download6812', 'option', 0) = 0) then
  begin
    actDumpMemory.Enabled := True;
    actDumpMemory.Visible := True;
  end
  else
  begin
    actDumpMemory.Enabled := False;
    actDumpMemory.Visible := False;
  end;
end;

procedure TMainForm.actHyperBaudUpdate(Sender: TObject);
begin
  if (SelectedFamily = '68hc12') and iniFile.ReadBool('Toolbar', 'EnableHyperbaud', True)
    and EnableCOMPort and (iniFile.ReadInteger('Download6812', 'option', 0) = 0) then
  begin
    actHyperBaud.Enabled := True;
    actHyperBaud.Visible := True;

    if InHyperBaud then
    begin
      actHyperBaud.ImageIndex := 19;
      actHyperBaud.Hint := 'Turn Hyperbaud Off';
    end
    else
    begin
      actHyperBaud.ImageIndex := 18;
      actHyperBaud.Hint := 'Turn Hyperbaud On';
    end;

  end
  else
  begin
    actHyperBaud.Enabled := False;
    actHyperBaud.Visible := False;
  end;
end;

procedure TMainForm.actFileCloseExecute(Sender: TObject);
var
  i: integer;
  LEditor: IEditor;
begin
  CloseAllDumpWindows;
  CloseListWindow;

  if CurrentFilename > '' then
  begin
    // find the correct editor
    // Since all other windows are closed, the only remaining editor is the main asm editor
    if GI_EditorFactory <> nil then
    begin
      for i := GI_EditorFactory.GetEditorCount - 1 downto 0 do
      begin
        LEditor := GI_EditorFactory.Editor[i];

        if CompareText(LEditor.GetFileName, CurrentFilename) = 0 then
        begin
          LEditor.Activate;
          LEditor.Close;
          Application.ProcessMessages;
         // MessageDlg('GI_EditorFactory.GetEditorCount: ' + IntToStr(GI_EditorFactory.GetEditorCount), mtInformation, [mbOK], 0);
          if GI_EditorFactory.GetEditorCount = 0 then
          begin
            fEditorForm := nil;
            CurrentFilename := '';

            // save the file we are closing in the MRU list
            CommandsDataModule.AddMRUEntry(CurrentFilename);
          end;
        end;

      end;
    end;
  end;
end;

procedure TMainForm.actFileCloseUpdate(Sender: TObject);
begin
  actFileClose.Enabled := (CurrentFilename <> '');
end;

procedure TMainForm.PageControl1Change(Sender: TObject);
begin
  if (PageControl1.ActivePage = tsTerminal) and EnableCOMPort then
    afDataTerminal1.SetFocus;
end;

procedure TMainForm.PrinterSetup1Click(Sender: TObject);
begin
  PrinterSetupDialog.Execute;
end;

procedure TMainForm.PageControl1Enter(Sender: TObject);
begin
  if (PageControl1.ActivePage = tsTerminal) and EnableCOMPort then
    afDataTerminal1.SetFocus;
end;

end.

